#include <classes/BOOPSI/decorgadgets.h>
#include <classes/BOOPSI/boopsilib.h>

#pragma -
#include <pragma/utility_lib.h>
#include <clib/alib_protos.h>
#include <pragma/intuition_lib.h>
#include <pragma/graphics_lib.h>
#pragma +

#define LABELDIST 2

struct BevelboxData {
	Object *frame;
	Object *pattern;
	struct TextAttr *tattr;
	struct TextFont *font;
	BOOL highlighted;
	ULONG labelplace;
	WORD leftborder;
	WORD rightborder;
	WORD topborder;
	WORD bottomborder;
	WORD innertopborder;
};

BevelboxClass::BevelboxClass()
	: BoopsiClass(sizeof(struct BevelboxData),(ULONG (*)()) &dispatcher,GADGETCLASS,NULL)
{
}

ULONG BevelboxClass::dispatcher(Class *cl, Object *o, Msg msg)
{
	struct BevelboxData *data;
	ULONG retval = FALSE;
	switch (msg->MethodID)
	{
		case OM_NEW:
		{
			Object *object;
			if (object = (Object *) DoSuperMethodA(cl,o,msg))
			{
				data = (struct BevelboxData *) INST_DATA(cl,object);
				LONG orecessed = TRUE;
				LONG oframetype = FRAME_RIDGE;
				BOOL oframe = TRUE;
				BOOL oedges = TRUE;
				data->frame = NULL;
				data->pattern = NULL;
				data->tattr = NULL;
				data->highlighted = FALSE;
				data->labelplace = BB_LabelAbove;
				TagItemCursorC tic(((struct opSet *) msg)->ops_AttrList);
				while (!tic.isDone()) {
					/* register */ ULONG ticData = tic.itemData();
					switch (tic.itemTag())
					{
						case IA_Recessed:
							orecessed = ticData;
							break;
						case IA_FrameType:
							oframetype = ticData;
							break;
						case IA_EdgesOnly:
							oedges = (BOOL) ticData;
							break;
						case BBA_Font:
							data->tattr = (struct TextAttr *) ticData;
							break;
						case BBA_Highlighted:
							data->highlighted = (BOOL) ticData;
							break;
						case BBA_LabelPlace:
							data->labelplace = (ULONG) ticData;
							break;
						case BBA_Pattern:
							data->pattern = (Object *) ticData;
							break;
						case BBA_Frame:
							oframe = (BOOL) ticData;
							break;
						default:
							break;
					};
					tic.next();
				};
				if (data->tattr)
					data->font = OpenFont(data->tattr);
				calcBorders(cl,(struct Gadget *) object,data);
				if (oframe)
				{
					if (data->pattern)
						oedges = TRUE;
					data->frame = (Object *) NewObject(NULL,FRAMEICLASS,
						IA_EdgesOnly, oedges,
						IA_Recessed, orecessed,
						IA_FrameType, oframetype,
						TAG_END);
				};
				retval = (ULONG) object;
			};
			break;
		};
		case OM_DISPOSE:
		{
			data = (struct BevelboxData *) INST_DATA(cl,o);
			if (data->frame)
				DisposeObject((APTR) data->frame);
			if (data->font)
				CloseFont(data->font);
			retval = DoSuperMethodA(cl,o,msg);
			break;
		};
		case OM_GET:
		{
			data = (struct BevelboxData *) INST_DATA(cl,o);
			switch (((struct opGet *) msg)->opg_AttrID)
			{
				case GA_Left:
					*(((struct opGet *) msg)->opg_Storage) = ((struct Gadget *) o)->LeftEdge;
					retval = TRUE;
					break;
				case GA_Top:
					*(((struct opGet *) msg)->opg_Storage) = ((struct Gadget *) o)->TopEdge;
					retval = TRUE;
					break;
				case GA_Width:
					*(((struct opGet *) msg)->opg_Storage) = ((struct Gadget *) o)->Width;
					retval = TRUE;
					break;
				case GA_Height:
					*(((struct opGet *) msg)->opg_Storage) = ((struct Gadget *) o)->Height;
					retval = TRUE;
					break;
				case BBA_Font:
					*(((struct opGet *) msg)->opg_Storage) = (ULONG) data->tattr;
					retval = TRUE;
					break;
				case BBA_Highlighted:
					*(((struct opGet *) msg)->opg_Storage) = (ULONG) data->highlighted;
					retval = TRUE;
					break;
				case BBA_TopBorder:
					*(((struct opGet *) msg)->opg_Storage) = (ULONG) data->topborder;
					retval = TRUE;
					break;
				case BBA_BottomBorder:
					*(((struct opGet *) msg)->opg_Storage) = (ULONG) data->bottomborder;
					retval = TRUE;
					break;
				case BBA_LeftBorder:
					*(((struct opGet *) msg)->opg_Storage) = (ULONG) data->leftborder;
					retval = TRUE;
					break;
				case BBA_RightBorder:
					*(((struct opGet *) msg)->opg_Storage) = (ULONG) data->rightborder;
					retval = TRUE;
					break;
				case BBA_InnerTopBorder:
					*(((struct opGet *) msg)->opg_Storage) = (ULONG) data->innertopborder;
					retval = TRUE;
					break;
				case BBA_InnerBottomBorder:
					*(((struct opGet *) msg)->opg_Storage) = 0;
					retval = TRUE;
					break;
				case BBA_InnerLeftBorder:
					*(((struct opGet *) msg)->opg_Storage) = 0;
					retval = TRUE;
					break;
				case BBA_InnerRightBorder:
					*(((struct opGet *) msg)->opg_Storage) = 0;
					retval = TRUE;
					break;
				default:
					retval = DoSuperMethodA(cl,o,msg);
					break;
			};
			break;
		};
		case OM_SET:
		{
			data = (struct BevelboxData *) INST_DATA(cl,o);
			TagItemCursorC tic(((struct opSet *) msg)->ops_AttrList);
			while (!tic.isDone()) {
				/* register */ ULONG ticData = tic.itemData();
				switch (tic.itemTag())
				{
					case BBA_Font:
						if (data->font)
						{
							CloseFont(data->font);
							data->font = NULL;
						};
						data->tattr = (struct TextAttr *) ticData;
						if (data->tattr)
							data->font = OpenFont(data->tattr);
						calcBorders(cl,(struct Gadget *) o,data);
						break;
					default:
						break;
				};
				tic.next();
			};
			retval = DoSuperMethodA(cl,o,msg);
			break;
		};
		case GM_RENDER:
		{
			data = (struct BevelboxData *) INST_DATA(cl,o);
			retval = renderBevelbox(cl,(struct Gadget *) o,
				(struct gpRender *) msg,data);
			break;
		};
		case GM_HITTEST:
		{
			retval = 0;
			break;
		};
		default:
		{
			retval = DoSuperMethodA(cl,o,msg);
			break;
		};
	};
	return retval;
}

ULONG BevelboxClass::renderBevelbox(Class *cl, struct Gadget *g,
	struct gpRender *msg, struct BevelboxData *data)
{
	struct RastPort *rp;
	struct GadgetInfo *ginfo;
	if (msg->MethodID == OM_SET || msg->MethodID == OM_UPDATE)
		ginfo = ((struct opSet *) msg)->ops_GInfo
	else
		ginfo = msg->gpr_GInfo;
	if (!ginfo)
		return TRUE;
	UWORD *pens = ginfo->gi_DrInfo->dri_Pens;
	if (msg->MethodID == GM_RENDER)
		rp = msg->gpr_RPort
	else
		rp = ObtainGIRPort(ginfo);
	if (rp)
	{
		if (data->pattern)
		{
			SetAttrs(data->pattern,
				IA_Left,g->LeftEdge, IA_Top,g->TopEdge,
				IA_Width,g->Width, IA_Height,g->Height,
				TAG_END);
			DrawImageState(rp,(struct Image *) data->pattern,0,0,
				IDS_NORMAL,msg->gpr_GInfo->gi_DrInfo);
		};
		if (data->frame)
		{
			SetAttrs(data->frame,
				IA_Left,g->LeftEdge, IA_Top,g->TopEdge,
				IA_Width,g->Width, IA_Height,g->Height,
				TAG_END);
			DrawImageState(rp,(struct Image *) data->frame,0,0,
				IDS_NORMAL,msg->gpr_GInfo->gi_DrInfo);
		};
		if (data->font && g->GadgetText)
		{
			SetAPen(rp,pens[data->highlighted ? HIGHLIGHTTEXTPEN : TEXTPEN]);
			SetBPen(rp,pens[BACKGROUNDPEN]);
			SetDrMd(rp,JAM2);
			SetFont(rp,data->font);
			PrintClipped(rp,(STRPTR) g->GadgetText,
				g->LeftEdge,g->TopEdge - data->topborder,
				g->Width,data->tattr->ta_YSize,STADJUST_Center);
		};
		if (msg->MethodID != GM_RENDER)
			ReleaseGIRPort(rp);
		return TRUE;
	};
	return FALSE;
}

VOID BevelboxClass::calcBorders(Class *cl, struct Gadget *g,
		struct BevelboxData *data)
{
	data->leftborder = 0;
	data->rightborder = 0;
	data->topborder = 0;
	data->bottomborder = 0;
	data->innertopborder = 0;
	if (data->tattr && g->GadgetText)
	{
		switch (data->labelplace)
		{
			case BB_LabelAbove:
				data->topborder = data->tattr->ta_YSize;
				break;
			case BB_LabelLine:
				data->topborder = (data->tattr->ta_YSize + 1) / 2;
				data->innertopborder = data->tattr->ta_YSize / 2;
				break;
		};
	};
}

// *************************************************************

VOID BBevelboxC::erase(WindowC *w)
{
	if (gadget_ob && w)
	{
		if (w->rastPort())
			EraseRect(w->rastPort(),
				gadget_ob->LeftEdge - getAttr(BBA_LeftBorder),
				gadget_ob->TopEdge - getAttr(BBA_TopBorder),
				gadget_ob->LeftEdge + gadget_ob->Width + getAttr(BBA_RightBorder),
				gadget_ob->TopEdge + gadget_ob->Height + getAttr(BBA_BottomBorder));
	};

}

BevelboxClass BBevelboxC::bbgc;

// *************************************************************

struct BevellineData {
	Object *line;
	struct TextAttr *tattr;
	struct TextFont *font;
	BOOL highlighted;
	BOOL vertical;
	ULONG labelplace;
	WORD leftborder;
	WORD rightborder;
	WORD topborder;
	WORD bottomborder;
};

BevellineClass::BevellineClass()
	: BoopsiClass(sizeof(struct BevellineData),(ULONG (*)()) &dispatcher,GADGETCLASS,NULL)
{
}

ULONG BevellineClass::dispatcher(Class *cl, Object *o, Msg msg)
{
	struct BevellineData *data;
	ULONG retval = FALSE;
	switch (msg->MethodID)
	{
		case OM_NEW:
		{
			Object *object;
			if (object = (Object *) DoSuperMethodA(cl,o,msg))
			{
				data = (struct BevellineData *) INST_DATA(cl,object);
				LONG orecessed = TRUE;
				LONG oframetype = FRAME_RIDGE;
				data->tattr = NULL;
				data->font = NULL;
				data->highlighted = FALSE;
				data->vertical = FALSE;
				data->labelplace = BL_LabelAbove;
				TagItemCursorC tic(((struct opSet *) msg)->ops_AttrList);
				while (!tic.isDone()) {
					/* register */ ULONG ticData = tic.itemData();
					switch (tic.itemTag())
					{
						case IA_Recessed:
							orecessed = ticData;
							break;
						case IA_FrameType:
							oframetype = ticData;
							break;
						case BLA_Font:
							data->tattr = (struct TextAttr *) ticData;
							break;
						case BLA_Highlighted:
							data->highlighted = (BOOL) ticData;
							break;
						case BLA_Vertical:
							data->vertical = (BOOL) ticData;
							break;
						case BLA_LabelPlace:
							data->labelplace = (ULONG) ticData;
							break;
						default:
							break;
					};
					tic.next();
				};
				if (data->tattr)
					data->font = OpenFont(data->tattr);
				calcBorders(cl,(struct Gadget *) object, data);
				data->line = (Object *) NewObject(LineiC::lic.boopsiclass(),NULL,
					IA_Recessed, orecessed,
					IA_FrameType, oframetype,
					LIA_Vertical, data->vertical,
					TAG_END);
				retval = (ULONG) object;
			};
			break;
		};
		case OM_DISPOSE:
		{
			data = (struct BevellineData *) INST_DATA(cl,o);
			if (data->line)
				DisposeObject((APTR) data->line);
			if (data->font)
				CloseFont(data->font);
			retval = DoSuperMethodA(cl,o,msg);
			break;
		};
		case OM_GET:
		{
			data = (struct BevellineData *) INST_DATA(cl,o);
			switch (((struct opGet *) msg)->opg_AttrID)
			{
				case GA_Left:
					*(((struct opGet *) msg)->opg_Storage) = ((struct Gadget *) o)->LeftEdge;
					retval = TRUE;
					break;
				case GA_Top:
					*(((struct opGet *) msg)->opg_Storage) = ((struct Gadget *) o)->TopEdge;
					retval = TRUE;
					break;
				case GA_Width:
					*(((struct opGet *) msg)->opg_Storage) = ((struct Gadget *) o)->Width;
					retval = TRUE;
					break;
				case GA_Height:
					*(((struct opGet *) msg)->opg_Storage) = ((struct Gadget *) o)->Height;
					retval = TRUE;
					break;
				case BLA_Font:
					*(((struct opGet *) msg)->opg_Storage) = (ULONG) data->tattr;
					retval = TRUE;
					break;
				case BLA_Highlighted:
					*(((struct opGet *) msg)->opg_Storage) = (ULONG) data->highlighted;
					retval = TRUE;
					break;
				case BLA_Vertical:
					*(((struct opGet *) msg)->opg_Storage) = (ULONG) data->vertical;
					retval = TRUE;
					break;
				case BLA_TopBorder:
					*(((struct opGet *) msg)->opg_Storage) = (ULONG) data->topborder;
					retval = TRUE;
					break;
				case BLA_BottomBorder:
					*(((struct opGet *) msg)->opg_Storage) = (ULONG) data->bottomborder;
					retval = TRUE;
					break;
				case BLA_LeftBorder:
					*(((struct opGet *) msg)->opg_Storage) = (ULONG) data->leftborder;
					retval = TRUE;
					break;
				case BLA_RightBorder:
					*(((struct opGet *) msg)->opg_Storage) = (ULONG) data->rightborder;
					retval = TRUE;
					break;
				case BLA_LabelPlace:
					*(((struct opGet *) msg)->opg_Storage) = (ULONG) data->labelplace;
					retval = TRUE;
					break;
				default:
					retval = DoSuperMethodA(cl,o,msg);
					break;
			};
			break;
		};
		case OM_SET:
		{
			data = (struct BevellineData *) INST_DATA(cl,o);
			TagItemCursorC tic(((struct opSet *) msg)->ops_AttrList);
			while (!tic.isDone()) {
				/* register */ ULONG ticData = tic.itemData();
				switch (tic.itemTag())
				{
					case BBA_Font:
						if (data->font)
						{
							CloseFont(data->font);
							data->font = NULL;
						};
						data->tattr = (struct TextAttr *) ticData;
						if (data->tattr)
							data->font = OpenFont(data->tattr);
						calcBorders(cl,(struct Gadget *) o, data);
						break;
					default:
						break;
				};
				tic.next();
			};
			retval = DoSuperMethodA(cl,o,msg);
			break;
		};
		case GM_RENDER:
		{
			data = (struct BevellineData *) INST_DATA(cl,o);
			retval = renderBevelline(cl,(struct Gadget *) o,
				(struct gpRender *) msg,data);
			break;
		};
		case GM_HITTEST:
		{
			retval = 0;
			break;
		};
		default:
		{
			retval = DoSuperMethodA(cl,o,msg);
			break;
		};
	};
	return retval;
}

ULONG BevellineClass::renderBevelline(Class *cl, struct Gadget *g,
	struct gpRender *msg, struct BevellineData *data)
{
	struct RastPort *rp;
	struct GadgetInfo *ginfo;
	if (msg->MethodID == OM_SET || msg->MethodID == OM_UPDATE)
		ginfo = ((struct opSet *) msg)->ops_GInfo
	else
		ginfo = msg->gpr_GInfo;
	if (!ginfo)
		return TRUE;
	UWORD *pens = ginfo->gi_DrInfo->dri_Pens;
	if (msg->MethodID == GM_RENDER)
		rp = msg->gpr_RPort
	else
		rp = ObtainGIRPort(ginfo);
	if (rp)
	{
		if (data->line)
		{
			SetAttrs(data->line,
				IA_Left,g->LeftEdge,
				IA_Top,g->TopEdge,
				IA_Width,g->Width,
				IA_Height,g->Height,
				TAG_END);
			DrawImageState(rp,(struct Image *) data->line,0,0,
				IDS_NORMAL,msg->gpr_GInfo->gi_DrInfo);
		};
		if (!data->vertical && data->font && g->GadgetText)
		{
			SetAPen(rp,pens[data->highlighted ? HIGHLIGHTTEXTPEN : TEXTPEN]);
			SetBPen(rp,pens[BACKGROUNDPEN]);
			SetDrMd(rp,JAM2);
			SetFont(rp,data->font);
			PrintClipped(rp,(STRPTR) g->GadgetText,
				g->LeftEdge,g->TopEdge - data->topborder,
				g->Width,data->tattr->ta_YSize,STADJUST_Center);
		};
		if (msg->MethodID != GM_RENDER)
			ReleaseGIRPort(rp);
		return TRUE;
	};
	return FALSE;
}

VOID BevellineClass::calcBorders(Class *cl, struct Gadget *g,
		struct BevellineData *data)
{
	data->leftborder = 0;
	data->rightborder = 0;
	data->topborder = 0;
	data->bottomborder = 0;
	if (!data->vertical && data->tattr && g->GadgetText)
	{
		switch (data->labelplace)
		{
			case BB_LabelAbove:
				data->topborder = data->tattr->ta_YSize;
				break;
			case BB_LabelLine:
				data->topborder = (data->tattr->ta_YSize + 1) / 2;
				data->bottomborder = data->tattr->ta_YSize / 2;
				break;
		};
	};
}

// *************************************************************

VOID BBevellineC::erase(WindowC *w)
{
	if (gadget_ob && w)
	{
		if (w->rastPort())
			EraseRect(w->rastPort(),
				gadget_ob->LeftEdge - getAttr(BLA_LeftBorder),
				gadget_ob->TopEdge - getAttr(BLA_TopBorder),
				gadget_ob->LeftEdge + gadget_ob->Width + getAttr(BLA_RightBorder),
				gadget_ob->TopEdge + gadget_ob->Height + getAttr(BLA_BottomBorder));
	};

}

BevellineClass BBevellineC::blgc;

// *************************************************************
